"""
Django settings for seawatch_planner project.

Generated by 'django-admin startproject' using Django 2.2.6.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import warnings
from typing import Optional

import environ
from django.contrib.messages import constants as messages
from django.utils.deprecation import RemovedInDjango60Warning  # type: ignore
from django.utils.translation import gettext_lazy as _

env = environ.Env()

PROJECT_DIR = environ.Path(__file__) - 4

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# Application definition

INSTALLED_APPS = [
    # Django
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.humanize",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django.forms",
    # 3rd party
    "bootstrap4",
    "fontawesome_5",
    "django_tables2",
    "django_filters",
    "modeltranslation",
    "django_countries",
    "webpack_loader",
    "procrastinate.contrib.django",
    "tailwind",
    # Ours
    "planner_common",
    "operations",
    "missions",
    "seawatch_registration",
    "applications",
    "volunteers",
    "history",
    "public",
    "theme",
    # cleanup needs to be last
    "django_cleanup.apps.CleanupConfig",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "seawatch_planner.middleware.vhosts",
    "django.middleware.locale.LocaleMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "seawatch_planner.middleware.ensurePasswordIsntInErrorMailMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "seawatch_planner.middleware.RequireLoginMiddleware",
    "history.middleware.history_actor_middleware",
    "seawatch_planner.middleware.HttpResponseNotAllowedMiddleware",
]

ROOT_URLCONF = "seawatch_planner.empty_dummy_urls"
BACKOFFICE_URLCONF = "seawatch_planner.urls"
PUBLIC_URLCONF = "public.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [str(PROJECT_DIR + "templates")],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "seawatch_planner.context_processors.skip_js",
                "seawatch_planner.context_processors.env_warning",
                "seawatch_planner.context_processors.features",
            ],
        },
    },
    {"BACKEND": "htpy.django.HtpyTemplateBackend", "NAME": "htpy"},
]

WSGI_APPLICATION = "seawatch_planner.wsgi.application"

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

# Default id field
DEFAULT_AUTO_FIELD = "django.db.models.AutoField"

# Message system
# Bootstrap labels

MESSAGE_TAGS = {
    messages.DEBUG: "alert-info",
    messages.INFO: "alert-info",
    messages.SUCCESS: "alert-success",
    messages.WARNING: "alert-warning",
    messages.ERROR: "alert-danger",
}

# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = "en"

TIME_ZONE = "Europe/Berlin"

USE_TZ = True

# Tell Django where the project's translation files should be.
LOCALE_PATHS = [PROJECT_DIR("locale")]


LANGUAGES = [("en", _("English"))]


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.0/howto/static-files/

STATIC_URL = "/static/"
STATIC_ROOT = PROJECT_DIR("staticfiles")

# Note that the middleware allows all public urls regardless of this setting
LOGIN_REQUIRED_URLS_EXCEPTIONS = [
    r"/accounts/",
    r"/static/",
    r"/favicon.ico",
    r"/_testing",
    r"/robots.txt$",
    r"/.well-known/traffic-advice$",
]
LOGIN_REDIRECT_URL = "/applications"

# Bootstrap Config
BOOTSTRAP4 = {
    "required_css_class": "required",
    "css_url": f"{STATIC_URL}vendor/bootstrap4/bootstrap.min.css",
    "javascript_url": f"{STATIC_URL}vendor/bootstrap4/bootstrap.bundle.min.js",
    "jquery_url": f"{STATIC_URL}vendor/bootstrap4/jquery-3.5.1.min.js",
    "jquery_slim_url": f"{STATIC_URL}vendor/bootstrap4/jquery-3.5.1.slim.min.js",
}

ENABLE_TESTING_API = env.str("PLANNER_ENABLE_TESTING_API", None)  # type: ignore
if ENABLE_TESTING_API == "I 100% know what I'm doing by enabling this":
    INSTALLED_APPS = [*INSTALLED_APPS[:-1], "testing_api", INSTALLED_APPS[-1]]


# EMAIL defaults
# SUBJECT PREFIX FOR INTERNAL MAIL
EMAIL_SUBJECT_PREFIX = env.get_value(
    "PLANNER_EMAIL_SUBJECT_PREFIX",
    default="[CrewingDB] ",  # type: ignore
    cast=str,
)

SHOW_ENV_WARNING: Optional[str] = None

FORMAT_MODULE_PATH = ["seawatch_planner.formats"]


FORM_RENDERER = "django.forms.renderers.TemplatesSetting"

warnings.filterwarnings(
    "ignore",
    "The FORMS_URLFIELD_ASSUME_HTTPS transitional setting is deprecated.",
    RemovedInDjango60Warning,
)
FORMS_URLFIELD_ASSUME_HTTPS = True

# This needs to be overridden with the missing fields filled in in specific settings
WEBPACK_LOADER_DEFAULT_DEFAULTS = {
    # "CACHE": True,
    "BUNDLE_DIR_NAME": "compiled/",
    # "STATS_FILE": "/path/to/webpack-stats.json",
    "IGNORE": [r".+\.hot-update.js", r".+\.map"],
    "POLL_INTERVAL": 0.1,
    "TIMEOUT": None,
    "LOADER_CLASS": "webpack_loader.loaders.WebpackLoader",
}

ATOMIC_REQUESTS = True

TAILWIND_APP_NAME = "theme"
